
import requests
import json
from datetime import datetime, timedelta
import hashlib

import threading
import time
name="jesse"
inputpass="kpl..87788"


# 解算时间
daytime = datetime.now().strftime("%Y-%m-%d")


token=""



def upToken():
     while True:
        # 获取当前时间的小时、分钟和秒数
        current_hour = time.localtime().tm_hour
        current_minute = time.localtime().tm_min
        current_second = time.localtime().tm_sec

        # 计算距离下一个8小时的等待时间
        seconds_until_next_8_hour = ((8 - (current_hour % 8)) * 3600
                                     - current_minute * 60
                                     - current_second)

        # 等待直到下一个8小时的开始
        time.sleep(seconds_until_next_8_hour)
        token=login()

def upOnlineNum():
    current_second = time.localtime().tm_sec

    # 等待直到下一个分钟的开始
    time.sleep(60 - current_second)
    amount,company_amount_free,company_amount_going=getNowDateOnlineCar()
    # 统计信息
    updata_server('static',{
        'online_total':amount,
        'online_free':company_amount_free,
        'online_hour':company_amount_going,
        'ftime':daytime
    })

# 模拟登录 防止token变化导致无法请求
def login():
    a=datetime.now() - timedelta(hours=8)
    n=sha256_hash(name+','+inputpass)
    key_login=sha256_hash(n+","+a.strftime("%Y-%m-%d"))
    print(key_login)
    data={
     'req_param':{
     "key_login":key_login,
     'name':name,
     'client_time':a.strftime("%Y-%m-%d %H:%M:%S")
     },
     'task':1002,
     'task_num':1
    }
    res=obtain_server_data("1002-1","login",data)
    return res['token']


# 当前时段在线车辆 ,在线总数，空闲车辆，训练车辆
def getNowDateOnlineCar():
    data={
     'req_param':{
        "begin":0,
        'column':[
            "id",
            "sn",
            "hphm",
            "id_student",
            "id_coach",
            "state",
            "judge_mode"
         ],
        'condition':{"state": ["1","3"]},
        'limit':5
     },
     'task':5001,
     'task_num':1,
     'token':token
    }
    res=obtain_server_data("5001-1","jp_query_car",data)
    return int(res['company_amount_free'])+int(res['company_amount_going']),res['company_amount_free'],res['company_amount_going']

# 请求方法
def obtain_server_data(api_id,api_name,data):
    url = f"https://j.kplzj.com/api/request?n={api_id}&api={api_name}"  # 替换为你要发送POST请求的URL
    print(url)
    # 发送POST请求
    proxies = {
        "http": None,
        "https": None,
    }
    response = requests.post(url,proxies=proxies, verify=False, data=json.dumps(data,ensure_ascii=False))
    # 检查请求是否成功
    if response.status_code == 200:
        res= json.loads(response.text)
        if res['state']==0:
            print("POST请求成功！")
            return res
    else:
        print("POST请求失败，状态码：", response.status_code)
        print("错误信息：", response.text)
    return

# 存储接口
def updata_server(api_id,data):
    url = f'http://119.96.145.175:12103/api/smart/save/{api_id}'

    
    
    response = requests.post(url, data=json.dumps(data))
    # 检查请求是否成功
    if response.status_code == 200:
        res= json.loads(response.text)
        if res['code']==0:
            print('更新成功！')
            return res
    else:
        print('POST请求失败，状态码：', response.status_code)
        print('错误信息：', response.text)
    return


    


# sha256加密
def sha256_hash(input_string):
    # 将字符串转换为UTF-8编码
    input_bytes = input_string.encode('utf-8')
    
    # 创建SHA-256哈希对象
    sha256_hash_object = hashlib.sha256()
    
    # 更新哈希对象以处理输入字节
    sha256_hash_object.update(input_bytes)
    
    # 获取十六进制表示的哈希结果
    hashed_string = sha256_hash_object.hexdigest()
    
    return hashed_string


if __name__ == '__main__':
    
    # #获取token
    # token=login()
    # amount,company_amount_free,company_amount_going=getNowDateOnlineCar()
    
    token=login()
    threading.Thread(target=upToken).start()
    threading.Thread(target=upOnlineNum).start()